! ESA (C) 2000-2018 
!
! This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
!
!    SAS is free software: you can redistribute it and/or modify
!    it under the terms of the GNU General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    SAS is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU General Public License for more details.
!
!    You should have received a copy of the GNU General Public License
!    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
! This example shows how the addtable()
! function is used.
program example_addtable

  use dal
  
  implicit none

  type(DataSetT) set
  type(TableT) tab
  type(BlockT) blk
  integer i

  set = dataSet("test.dat",CREATE)
  tab = addTable(set,"table1",10)
  tab = addTable(set,"table2",100)
  tab = addTable(set,"table3",1000)

  do i=0,numberOfBlocks( set ) - 1
    blk = block( set, i, MODIFY )
    write(*,*) name( blk )
    call addComment( blk, "A table comment" )
  end do

  call release(set)

end program example_addtable
