! ESA (C) 2000-2018 
!
! This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
!
!    SAS is free software: you can redistribute it and/or modify
!    it under the terms of the GNU General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    SAS is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU General Public License for more details.
!
!    You should have received a copy of the GNU General Public License
!    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
program example_columnunits

  use dal
  
  implicit none

  type(DataSetT) set
  type(TableT) tab
  type(ColumnT) col
  integer i, coltype

  set = dataSet("test.dat",CREATE)
  tab = addTable(set,"some table",100)

  col = addColumn(tab,"bool",BOOLEAN)
  col = addColumn(tab,"int8",INTEGER8,units="cm",comment="int8 column")
  col = addColumn(tab,"int16",INTEGER16,units="dm",comment="int16 column")
  col = addColumn(tab,"int32",INTEGER32,units="m",comment="in32 column")
  col = addColumn(tab,"real32",REAL32,units="Dm",comment="real32 column")
  col = addColumn(tab,"real64",REAL64,units="hm",comment="real64 column")
  col = addColumn(tab,"string",STRING,comment="string column",dimensions=(/80/))

  do i=0, numberOfColumns( tab ) - 1
	    col = column( tab, i, READ )
    coltype = columnDataType( col )
    if(coltype.eq.INTEGER8.or.coltype.eq.INTEGER16.or.coltype.eq.INTEGER32 &
    .or.coltype.eq.REAL32.or.coltype.eq.REAL64) then
      write(*,*) units( col )
    end if
  end do

  call release(set)

end program example_columnunits
