! ESA (C) 2000-2018 
!
! This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
!
!    SAS is free software: you can redistribute it and/or modify
!    it under the terms of the GNU General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    SAS is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU General Public License for more details.
!
!    You should have received a copy of the GNU General Public License
!    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
! This examples show how to use the copyColumn function.
program example_copycolumn

  use dal
  
  implicit none

  type(DataSetT) set1, set2
  type(TableT) tab1, tab2
  type(ColumnT) col1, col2, col3, col4
  integer(kind=int32), dimension(:), pointer :: i32
  real(kind=single), dimension(:), pointer :: r32
  integer i

  set1 = dataSet("test.dat",CREATE)
  tab1 = addTable(set1,"some table",100)

  col1 = addColumn(tab1,"col1",INTEGER32,units="m",comment="in32 column")
  i32 => int32Data(col1)
  do i=0,numberOfRows(tab1)-1
    i32(i) = 3*i
  end do
  call release( col1)

  col2 = addColumn(tab1,"col2",REAL32,units="Dm",comment="real32 column")
  r32 => real32Data(col2)
  do i=0,numberOfRows(tab1)-1
    r32(i) = 0.5*i
  end do
  call release( col2)

  set2 = dataSet("test1.dat",CREATE)
  tab2 = addTable(set2,"some table",100)
  call copyColumn( tab2, col1 )
  call copyColumn( tab2, col2, "col3" )

  col3 = column( tab2, name( col1 ), READ )
  col4 = column( tab2, "col3", READ )
  i32 => int32Data(col3)
  r32 => real32Data(col4)
  do i = 0, numberOfRows( tab2 ) - 1
    write(*,*) i32(i), r32(i) 
  end do
  call release(col3)
  call release(col4)

  call release(set1)
  call release(set2)

end program example_copycolumn
