! ESA (C) 2000-2018 
!
! This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
!
!    SAS is free software: you can redistribute it and/or modify
!    it under the terms of the GNU General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    SAS is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU General Public License for more details.
!
!    You should have received a copy of the GNU General Public License
!    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
! This example shoes how the hasAttribute interface is used.
program example_hasattribute

  use dal
  implicit none
   
  type(DataSetT) set
  type(AttributeT) att

  set = dataSet("test.dat",CREATE)
  call setAttribute(set,"sbool1",.false.,"dataset bool comment")

  if( hasAttribute( set, "sbool2" ) ) then
    write(*,*) 'That is not possible'
  end if

  if( hasAttribute( set, "sbool1" ) ) then
    att = attribute( set, "sbool1" )
    write(*,*) name( att ), " = ", booleanAttribute( att )
  end if

  call release(set)
   
end program example_hasattribute
