! ESA (C) 2000-2018 
!
! This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
!
!    SAS is free software: you can redistribute it and/or modify
!    it under the terms of the GNU General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    SAS is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU General Public License for more details.
!
!    You should have received a copy of the GNU General Public License
!    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
! This example shows how int32 attributes are used.
! The program creates a dataset containing two int32 attributes,
! together with a table containing two int32 attributes.
! The attributes are then accessed, by name, with
! the int32Attribute() function.
! Also, it is shown how to access the attributes by position.
program example_int32attribute
   
  use dal
  use errorhandling
  implicit none
   
  type(DataSetT) set
  type(TableT) tab
  type(AttributeT) att
  integer i

  set = dataSet("test.dat",CREATE)
  call setAttribute(set,"int1",1,"int comment")
  call setAttribute(set,"int2",2,"int comment")
   
  tab = addTable(set,"table",10);
  call setAttribute(tab,"int1",3,"int comment")
  call setAttribute(tab,"int2",4,"int comment")

  write(*,*) int32Attribute( set, "int1" ) ! output '1'
  write(*,*) int32Attribute( set, "int2" ) ! output '2'
  write(*,*) int32Attribute( tab, "int1" ) ! output '3'
  write(*,*) int32Attribute( tab, "int2" ) ! output '4'

  do i = 0, numberOfAttributes( set ) - 1
  	att = attribute( set, i )
	write(*,*) int32Attribute( att ) ! output the sequence 1, 2
  end do

  call release(set)

end program example_int32attribute
