! ESA (C) 2000-2018 
!
! This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
!
!    SAS is free software: you can redistribute it and/or modify
!    it under the terms of the GNU General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    SAS is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU General Public License for more details.
!
!    You should have received a copy of the GNU General Public License
!    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
! This example shows how real64 attributes are used.
! The program creates a dataset containing two real64 attributes,
! together with a table containing two real64 attributes.
! The attributes are then accessed, by name, with
! the real64Attribute() function.
! Also, it is shown how to access the attributes by position.
program example_real64attribute
   
  use dal
  use errorhandling
  implicit none
   
  type(DataSetT) set
  type(TableT) tab
  type(AttributeT) att
  integer i

  set = dataSet("test.dat",CREATE)
  call setAttribute(set,"real1",1.0,"real comment")
  call setAttribute(set,"real2",2.0,"real comment")
   
  tab = addTable(set,"table",10);
  call setAttribute(tab,"real1",3.0,"real comment")
  call setAttribute(tab,"real2",4.0,"real comment")

  write(*,*) real64Attribute( set, "real1" ) ! output '1.0'
  write(*,*) real64Attribute( set, "real2" ) ! output '2.0'
  write(*,*) real64Attribute( tab, "real1" ) ! output '3.0'
  write(*,*) real64Attribute( tab, "real2" ) ! output '4.0'

  do i = 0, numberOfAttributes( set ) - 1
  	att = attribute( set, i )
	write(*,*) real64Attribute( att ) ! output the sequence 1.0, 2.0
  end do

  call release(set)

end program example_real64attribute
