! ESA (C) 2000-2018 
!
! This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
!
!    SAS is free software: you can redistribute it and/or modify
!    it under the terms of the GNU General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    SAS is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU General Public License for more details.
!
!    You should have received a copy of the GNU General Public License
!    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
module autof90

use dal

type(ColumnDataT) xData, yData, rData

contains

  subroutine proc(st)
    type(SubTableT) :: st
    integer(kind=int16), dimension(:), pointer :: x,y
    real(kind=double), dimension(:), pointer :: r

    ! one could use data(st,"x") instead of xData
    x => int16Data(xData)
    y => int16Data(yData)
    r => real64Data(rData)
    write(*,*) x, y
    r = sqrt( sqr(x) + sqr(y) )
  end subroutine

  subroutine auto()
    type(DataSetT) set
    type(TableT) tab
    type(SubTableT) st

    set = dataSet("test.dat",MODIFY)
    tab = table(set,"events",MODIFY)
    st = subTable(tab)
    xData = addColumn(st,"x",READ)
    yData = addColumn(st,"y",READ)
    rData = addColumn(st,"r",CREATE)
    call forEachSubTable(st, proc)
    call release(set)
  end subroutine

end module
