! ESA (C) 2000-2018 
!
! This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
!
!    SAS is free software: you can redistribute it and/or modify
!    it under the terms of the GNU General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    SAS is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU General Public License for more details.
!
!    You should have received a copy of the GNU General Public License
!    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
module dal

  use daltypes

  integer, parameter :: READ = 10
  integer, parameter :: CREATE = 11
  integer, parameter :: MODIFY = 12

contains

  function int16Data(colData)
    type(ColumnDataT), intent(in) :: colData
    integer(kind=int16), dimension(:), pointer :: int16Data
  end function

  function real64Data(colData)
    type(ColumnDataT), intent(in) :: colData
    real(kind=double), dimension(:), pointer :: real64Data
  end function

  function dataSet(name,mode)
    character(len=*), intent(in) :: name
    integer, intent(in) :: mode
    type(DataSetT) dataSet
  end function

  function table(set,name,mode)
    type(DataSetT), intent(in) :: set
    character(len=*), intent(in) :: name
    integer, intent(in) :: mode
    type(TableT) table
  end function

  function subTable(tab)
    type(TableT), intent(in) :: tab
    type(SubTableT) subTable
  end function

  function addColumn(subtab,col,mode)
    type(SubTableT), intent(in) :: subtab
    character(len=*), intent(in) :: col
    integer, intent(in) :: mode
    type(ColumnDataT) addColumn
  end function

  function next(subtab)
    type(SubTableT), intent(in) :: subtab
    logical next
  end function

end module dal
