// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
typedef short int16;
typedef double real64;

typedef int ColumnData;
typedef int SubTable;
typedef int DataSet;
typedef int Table; 

typedef enum { READ, MODIFY, CREATE } AccessMode;

double sqr(double a) { return a*a; }

DataSet*	dataSet(char*,AccessMode);
void		dataSetRelease();

Table*		table(DataSet*,char*,AccessMode);

int16*		int16Data(ColumnData*);
real64*		real64Data(ColumnData*);

void		forEachSubTable(SubTable*,void (*proc)(SubTable*));

SubTable*	subTable(Table*);
ColumnData*	subTableAddColumn(SubTable*,char*,AccessMode);
unsigned long	subTableCount(SubTable*);
int		subTableNext(SubTable*);
void		subTableSeek(SubTable*, unsigned long, unsigned long);
void		subTableRelease(SubTable*);
