! ESA (C) 2000-2018 
!
! This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
!
!    SAS is free software: you can redistribute it and/or modify
!    it under the terms of the GNU General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    SAS is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU General Public License for more details.
!
!    You should have received a copy of the GNU General Public License
!    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
module autof90

use dal

type(ColumnT) :: xCol, yCol, rCol

contains

  subroutine proc(tab)
    type(TableT) :: tab
    integer(kind=int16), dimension(:), pointer :: x,y
    real(kind=double), dimension(:), pointer :: r

    x => int16Data(xCol)
    y => int16Data(yCol)
    r => real64Data(rCol)
    write(*,*) x, y
    r = sqrt( sqr(x) + sqr(y) )
  end subroutine

  subroutine auto()
    type(DataSetT) set
    type(TableT) tab

    set = dataSet("test.dat",MODIFY)
    tab = table(set,"events",MODIFY)
    xCol = column(tab,"x",READ)
    yCol = column(tab,"y",READ)
    rCol = column(tab,"r",CREATE)
    call forEachSubTable(st, proc)
    call release(set)
  end subroutine

end module
