// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
//-----------------------------------------------------------------------------
//
//		XMM Science Analysis System (SAS)
//		(c) 1998 European Space Agency
//
//-----------------------------------------------------------------------------
//
//	Child.h defines the abstract class Child that represents a
//	child of another class
//
//	DESCRIPTION:
//
//
//	USAGE EXAMPLES:
//
//	CHANGE HISTORY:
//		MT, 1998-10-01: 0.1.0: - first version
//
//	AUTHOR:
//		M.Thomas
//
//	REFERENCES:
//
//	$Id: Child.h,v 1.2 2004/03/05 14:43:00 eojero Exp $
///
#ifndef CHILD_H
#define CHILD_H

template<class T> class Child
{
public :
    virtual ~Child() {}
    virtual T * parent() = 0;
    virtual const T * parent() const = 0;
    virtual void parent( const T * parent ) = 0;
    virtual bool isOrphan() const = 0;
};

#endif


