// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
//  Giuseppe Vacanti (cosine science & computing bv)
//  September  2, 2002
// 
//   $Id: DalAux.cc,v 1.2 2004/03/05 14:43:00 eojero Exp $
#include <DalAux.h>
#include <errstr.h>

namespace {
    const std::string prefix("*DAL*");
};    


void DalAux::Message(const std::string & text, Msg::Verbosity level){
    Sas::message(Msg::Core, level, prefix + text);
}

void DalAux::Error(const string & text, const string & code){
    Sas::error(code, prefix + text);
}

void DalAux::Warning(const string & text, const string & code){
    Sas::warning(code, prefix + text);
}

