// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
/*************************************************************** 
* 
* DalArray.h & XMM Science Analysis System (SAS) 
* 
* Class representing DAL Array. 
* 
* (c) 1997 ESA - Written by Mark Thomas, CARA
* 
* $Id: DalArray.h,v 1.2 2004/03/05 14:43:00 eojero Exp $
* 
*****************************************************************/ 
#ifndef DAL_ARRAY_H
#define DAL_ARRAY_H


#include <Dal.h>


#include "DalDataComponent.h"
#include "DalBlock.h"
#include "DalDataSet.h"


class DalArray : public virtual Array, public DalBlock, public DalDataComponent
{
	public :
		DalArray(
			const std::string &			name,
			DataType			dataType,
			const longVec&			size,
			const std::string &			units,
			const std::string &			label,
			DalDataSet *			parent );

		virtual ~DalArray() {}
		virtual DalArray& operator=( const Array& ) = 0;

		ArrayData * data(
				const longVec &		from=zero,
				const longVec &		to=zero,
				AccessMode		accessMode=AsParent) const;

	private :

		virtual ArrayData * makeArrayData(
				AccessMode		accessMode ) const = 0;


};


#endif


