// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
/*************************************************************** 
* 
* DalArrayData.h            & XMM Science Analysis System (SAS) 
* 
* Class representing DAL Array Data.
* 
* (c) 1997 ESA - Written by Mark Thomas, CARA
* 
* $Id: DalArrayData.h,v 1.2 2004/03/05 14:43:00 eojero Exp $
* 
*****************************************************************/ 
#ifndef DAL_ARRAY_DATA_H
#define DAL_ARRAYDATA_H


#include <Dal.h>

#include "DalSeekable.h"
#include "DalChild.h"


class DalArrayData : public virtual ArrayData, public DalSeekable< longVec >, public DalChild<Array>
{
	public :

		DalArrayData(
			const Array *			parent,
			const longVec&			from,
			const longVec&			count );

    		unsigned long position( const longVec& pos ) const;

		virtual ~DalArrayData() {}
};


#endif


