// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
/*************************************************************** 
 * 
 * DalDal.h          & XMM Science Analysis System (SAS) 
 * 
 * Class representing Dal
 * 
 * (c) 1997 ESA - Written by Mark Thomas, CARA
 * 
 * $Id: DalDal.h,v 1.2 2004/03/05 14:43:01 eojero Exp $
 * 
 *****************************************************************/ 
#ifndef DAL_DAL_H
#define DAL_DAL_H


#include "Dal.h"


class DalDal : public virtual Dal {
public :
    
    DalDal( AccessMode accessMode, const DalDal * parentAccessMode );
 virtual ~DalDal() {}
    AccessMode mode() const;
    
    
    void mode( AccessMode newAccessMode );
    void alwaysAllowModify( bool onoff );
    void checkIfReadOnly() const;
    
private :
    
    AccessMode	_accessMode;
    bool	_alwaysAllowModify;
    const Dal *	_parentAccessMode;

};


#endif




