// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
/*************************************************************** 
* 
* DalSeekable.h & XMM Science Analysis System (SAS) 
* 
* Class representing a Seekable object.
* 
* (c) 1997 ESA - Written by Mark Thomas, CARA
* 
* $Id: DalSeekable.h,v 1.2 2004/03/05 14:43:01 eojero Exp $ 
* 
*****************************************************************/ 
#ifndef DAL_SEEKABLE_H
#define DAL_SEEKABLE_H


#include "Dal.h"
#include "Tracer.h"


template<class T>
class DalSeekable : public virtual Seekable<T>
{
	public :

		DalSeekable( T from, T count ) : _from( from ), _count( count ) { PROC ENDPROC }
		virtual ~DalSeekable(){}
		T from() const { PROC RETURN _from; }
		T count() const { PROC RETURN _count; }
		virtual void seek( T from, T count )  { PROC _from = from; _count = count; ENDPROC }

	private :
		T	_from;
		T	_count;
};



#endif


