// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
//  Giuseppe Vacanti (cosine science & computing bv)
//  September 13, 2002
// 
//   $Id: DataSetTracker.h,v 1.2 2004/03/05 14:43:02 eojero Exp $

#ifndef DATASETTRACKER_H
#define DATASETTRACKER_H

class DataSetRecord;

#include<map>
#include<string>
#include<iosfwd>

class DataSetTracker {
public:
    DataSetTracker();
    ~DataSetTracker();
    DataSetRecord & make_record(std::string const & name);
    DataSetRecord & get_record(std::string const & name) const;
    bool has_record(std::string const & name) const;
    unsigned long count() const;
    void printOn(ostream & os) const;

    typedef std::map<std::string, DataSetRecord *>::const_iterator const_iterator;
    typedef std::map<std::string, DataSetRecord *>::iterator iterator;
    iterator begin();
    const_iterator begin() const;
    iterator end();
    const_iterator end() const;



private:
    DataSetTracker(DataSetTracker const &);
    DataSetTracker & operator=(DataSetTracker const &);

    std::map<std::string, DataSetRecord *> db_;
};

// ostream & operator<<(ostream & os, const DataSetTracker & dst){
//     dst.printOn(os);
//     return os;
// }
    
#endif
