// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
#ifndef __DATA_MANIPULATOR
#define __DATA_MANIPULATOR

#include "Dal.h"


class DataManipulator
{
	public :

		virtual ~DataManipulator(){}
		virtual void dumpData(
				char ** 	 values,
				unsigned long 	 from,
				unsigned long 	 count  ) const = 0;
		virtual void dumpData(
				bool8 * 	 values,
				unsigned long 	 from,
				unsigned long 	 count  ) const = 0;
		virtual void dumpData(
				int8 * 		 values,
				unsigned long 	 from,
				unsigned long 	 count  ) const = 0;
		virtual void dumpData(
				uint16 * 	 values,
				unsigned long 	 from,
				unsigned long 	 count  ) const = 0;
		virtual void dumpData(
				int16 * 	 values,
				unsigned long 	 from,
				unsigned long 	 count  ) const = 0;
		virtual void dumpData(
				uint32 * 	 values,
				unsigned long 	 from,
				unsigned long 	 count  ) const = 0;
		virtual void dumpData(
				int32 * 	 values,
				unsigned long 	 from,
				unsigned long 	 count  ) const = 0;
		virtual void dumpData(
				real32 * 	 values,
				unsigned long 	 from,
				unsigned long 	 count  ) const = 0;
		virtual void dumpData(
				real64 * 	 values,
				unsigned long 	 from,
				unsigned long 	 count  ) const = 0;
		virtual void loadData(
				char ** 	 values,
				unsigned long 	 from,
				unsigned long 	 count  ) const = 0;
		virtual void loadData(
				bool8 * 	 values,
				unsigned long 	 from,
				unsigned long 	 count  ) const = 0;
		virtual void loadData(
				int8 * 		 values,
				unsigned long 	 from,
				unsigned long 	 count  ) const = 0;
		virtual void loadData(
				uint16 * 	 values,
				unsigned long 	 from,
				unsigned long 	 count  ) const = 0;
		virtual void loadData(
				int16 * 	 values,
				unsigned long 	 from,
				unsigned long 	 count  ) const = 0;
		virtual void loadData(
				uint32 * 	 values,
				unsigned long 	 from,
				unsigned long 	 count  ) const = 0;
		virtual void loadData(
				int32 * 	 values,
				unsigned long 	 from,
				unsigned long 	 count  ) const = 0;
		virtual void loadData(
				real32 * 	 values,
				unsigned long 	 from,
				unsigned long 	 count  ) const = 0;
		virtual void loadData(
				real64 * 	 values,
				unsigned long 	 from,
				unsigned long 	 count  ) const = 0;
		virtual void copyData(
				unsigned long 	 from,
				unsigned long 	 to,
				unsigned long 	 count ) const = 0;
};


#endif

