// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
/*************************************************************** 
* 
* HiLowTable.h             & XMM Science Analysis System (SAS) 
* 
* Class representing DAL data table.
* 
* (c) 1997 ESA - Written by Mark Thomas, CARA
* 
* $Id: HiLowTable.h,v 1.2 2004/03/05 14:43:02 eojero Exp $
* 
*****************************************************************/ 
#ifndef HILOW_TABLE_H
#define HILOW_TABLE_H


#include "Dal.h"
#include "DalTable.h"


class HiLowTable : public DalTable
{

	public :

		HiLowTable(
			const std::string &	name,
			unsigned long	rows,
			const std::string &	label,
			DalDataSet *	parent );

		HiLowTable(
			const Table & 	original,
			DalDataSet * 	parent,
			std::string 		newName = "" );

		virtual ~HiLowTable();

		DalTable& operator=( const Table& );
		void forEachSubTable( void(*callThisFunction)( Table * table ));
		//void seek( unsigned long from, unsigned long count );
		//void releaseAll();

	private :

		// Forbid
		HiLowTable(const HiLowTable&);

		DalColumn * makeColumn(
				const std::string &			name,
				Data::DataType			dataType,
				const std::string &			label,
				const std::string &			units,
				const longVec &			size,
				DalTable *			parent );

};


#endif
