// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
/*************************************************************** 
* 
* MemArrayData.h             & XMM Science Analysis System (SAS) 
* 
* Class representing array data object.
* 
* (c) 1997 ESA - Written by Mark Thomas, CARA
* 
* $Id: MemArrayData.h,v 1.2 2004/03/05 14:43:03 eojero Exp $ 
* 
*****************************************************************/ 
#ifndef MEM_ARRAY_DATA_H
#define MEM_ARRAY_DATA_H

#include <Dal.h>

#include "MemData.h"
#include "DataStorage.h"
#include "DalArrayData.h"
#include "DalArray.h"


class MemArrayData : public DalArrayData, public MemData<DalArray>
{
	public :

		MemArrayData(
			DataStorage *			data,
			const DalArray *		parent,
			const longVec&			from,
			const longVec&			count,
			AccessMode			accessMode );

		virtual ~MemArrayData();

		unsigned long elements() const;
		const longVec& size() const;

		void seek(
			const longVec & from,
			const longVec & count );

};

#endif
