// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
using namespace std;
/*************************************************************** 
* 
* DalReaderWriter.cc     & XMM Science Analysis System (SAS) 
* 
* Class representing Dal file reader/writer.
* 
* (c) 2000 ESA - Written by Mark Thomas, CARA
* 
* $Id: DalReaderWriter.cc,v 1.2 2004/03/05 14:43:03 eojero Exp $ 
* 
*****************************************************************/ 

#include <fstream>

#include "DalReaderWriter.h"


bool
DalReaderWriter::exists( const string& setName )
{
	PROC

	// Try reading the file
	ifstream ifs( setName.c_str() );

	// The file does not exist
	if (!ifs)
	{
		ALTRETURNV( false );
	} // if

	char s[7];
	ifs.read(s,6);
	s[6] = 0;
	string m(s);

	// Check whether the magic number is known
	if( m == magic() )
	{

		ALTRETURNV( true );

	} // if

	RETURN false;

}


