// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
/*************************************************************** 
* 
* MemFitsFileReaderWriter.h     & XMM Science Analysis System (SAS) 
* 
* Class representing FITS file reader/writer.
* 
* (c) 1997 ESA - Written by Mark Thomas, CARA
* 
* $Id: MemFitsReaderWriter.h,v 1.2 2004/03/05 14:43:03 eojero Exp $ 
* 
*****************************************************************/ 
#ifndef MEM_FITS_FILE_READER_WRITER_H
#define MEM_FITS_FILE_READER_WRITER_H


#include "FitsReaderWriter.h"
#include "MemFitsDatabase.h"


class MemFitsReaderWriter : public virtual FitsReaderWriter, public virtual MemFitsDatabase
{
	public :

		//MemFitsReaderWriter();
		virtual ~MemFitsReaderWriter(){}

		void read( DataSet* dataSet );
		void write( DataSet* dataSet );

	private :
		int writeColumns(
			fitsfile *	fptr,
			const Table &	table,
			int &		status ) const;

		int writeTable( 
			fitsfile *	fptr,
			const Table &	table,
			int &		status ) const;

		//virtual int readColumn(
		//	fitsfile *	fptr,
		//	int &		columnNumber,
		//	Table &		table,
		//	int &		status ) const;

		int readTable(
			fitsfile * 	fptr,
			DataSet &	dataSet,
			int &		status ) const;

		int readArray(
			fitsfile *	fptr,
			DataSet &	dataSet,
			int &		status ) const;

		int readPrimaryArray(
			fitsfile *		fptr,
			DataSet &		dataSet,
			KeywordChecker *	keywordChecker,
			int &			status ) const;

		int writeArray(
			fitsfile *	fptr,
			const Array &	array,
			int &		status ) const;

	protected :

		int readVariableLengthColumnData(
			fitsfile *	fptr,
			Column *	column,
			int &		status ) const;

		int readFixedLengthColumnData(
			fitsfile *	fptr,
			Column *	column,
			long offset,
			long nread,
			int &		status ) const;

};



#endif
