// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
using namespace std;
#include <Dal.h>
#include<cassert>
/* AI gcc4 porting
 * system was not declared in this scope => include cstdlib
 */
#include<cstdlib>
int main()
{
  DataSet*	set1;
  Table*	tab;
  Column*	col;
  ColumnData*	coldat;
  real32*	d;

  set1 = dataSetServer->open("test.dat",DataSet::Create);
  dataSetServer->close(set1);

  assert( dataSetServer -> exists( "test.dat" ));

  set1 = dataSetServer->open("test.dat",DataSet::Read);
  dataSetServer->close(set1);

  system( "chmod u-w test.dat" );

  set1 = dataSetServer->open("test.dat",DataSet::Read);
  dataSetServer->close(set1);

  system( "chmod u+w test.dat" );

  set1 = dataSetServer->open("test.dat",DataSet::Modify);
  tab = set1 -> addTable( "tab", 100 );
  col = tab -> addColumn( "col", Column::Real32 );
  coldat = col -> data();
  d = coldat -> real32Data();
  delete coldat;
  dataSetServer->close(set1);

  system( "chmod u-w test.dat" );

  set1 = dataSetServer->open("test.dat",DataSet::Read);
  tab = set1 -> table( "tab" );
  col = tab -> column( "col" );
  coldat = col -> data();
  d = coldat -> real32Data();
  delete coldat;
  dataSetServer->close(set1);

  system( "chmod u+w test.dat" );

  DataSet * set2 = dataSetServer->open("test.dat",DataSet::Modify);
  DataSet * set3 = dataSetServer->open("test1.dat",DataSet::Create);
  DataSet * set4 = dataSetServer->open("test2.dat",DataSet::Temp);
  dataSetServer->close(set2);
  dataSetServer->close(set3);
  dataSetServer->close(set4);

  return 0;
}
