// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
using namespace std;

#include<cassert>
#include <Dal.h>
//#include <ExceptionErrorHandler.h>
//#include <errstr.h>


int main()
{
  // *************************
  // Install exception handler
  // *************************
  //ExceptionErrorHandler local;
  //ErrorHandler* oldHandler = errHandler.handler(&local);
  //errHandler.name("ThisTestProgram");

  assert( dataSetServer -> client() == "" );
  DataSet * set = dataSetServer->open("test.dat",DataSet::Create);
  dataSetServer->close(set);
  assert( dataSetServer -> exists( "test.dat" ));
  assert( dataSetServer -> client() == "" );
  dataSetServer -> remove( "test.dat" );
  assert( !dataSetServer -> exists( "test.dat" ));
  assert( dataSetServer -> client() == "" );

  dataSetServer -> client( "CLIENT1" );
  assert( dataSetServer -> client() == "CLIENT1" );
  dataSetServer -> client( "CLIENT2" );
  assert( dataSetServer -> client() == "CLIENT2" );

  // Set the client, create a dataset, and then cleanup
  // the client.
  dataSetServer -> client( "CLIENT1" );
  assert( dataSetServer -> client() == "CLIENT1" );

  set = dataSetServer->open("test.dat",DataSet::Create);
  dataSetServer->close(set);
  assert( dataSetServer -> exists( "test.dat" ));
  assert( dataSetServer -> client() == "CLIENT1" );

  dataSetServer -> cleanupClient( "CLIENT1" );

  assert( dataSetServer -> exists( "test.dat" ));
  assert( dataSetServer -> client() == "CLIENT1" );

  set = dataSetServer->open("test.dat",DataSet::Create);
  dataSetServer -> cleanupClient( "CLIENT1" );
  // The following would fail (probably with a pure virtual called
  // error).
  // dataSetServer->close(set);
  
  //errHandler.handler(oldHandler); // return to default error handler

  return 0;
}
