// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
using namespace std;
#include<cassert>
#include <Dal.h>

int main()
{
  DataSet *set = dataSetServer->open("test.dat",DataSet::Create);
  Table *tab = set->addTable("someTable",0);

  tab->addColumn("bool",Column::Bool);
  tab->addColumn("int8",Column::Int8);
  tab->addColumn("int16",Column::Int16);
  tab->addColumn("int32",Column::Int32);
  tab->addColumn("real32",Column::Real32);
  tab->addColumn("real64",Column::Real64);
  //tab->addColumn("string",Column::DString);

  unsigned n = 0;
  for (unsigned i = 0; i < 10; ++i) {
    tab->insertRows(i,i);
    n += i;
    assert( tab->rows() == n );
  }

  for (unsigned i = 0; i < 5; ++i) {
    tab->deleteRows(i,i);
    n -= i;
    assert( tab->rows() == n );
  }

  dataSetServer->close(set);

  return 0;
}

