! ESA (C) 2000-2018 
!
! This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
!
!    SAS is free software: you can redistribute it and/or modify
!    it under the terms of the GNU General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    SAS is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU General Public License for more details.
!
!    You should have received a copy of the GNU General Public License
!    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
program test

  use dal
  use errorHandling
  
  implicit none

  type(DataSetT) set
  type(TableT) tab
  type(ArrayT) arr

  !call initerror("DALTEST")

  set = dataSet("test.dat",CREATE)

  tab = addTable(set,"table1",100)
  arr = addArray(set,"array1",Integer32, dimensions=(/ 3,3,3 /), position=0 )
  tab = addTable(set,"table2",100)
  if (blockNumber(set,"table1") /= 1) call error('',"wrong block number for table1")
  if (blockNumber(set,"array1") /= 0) call error('',"wrong block number for array1")
  if (blockNumber(set,"table2") /= 2) call error('',"wrong block number for table2")

  call release(set)

end program test
