! ESA (C) 2000-2018 
!
! This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
!
!    SAS is free software: you can redistribute it and/or modify
!    it under the terms of the GNU General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    SAS is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU General Public License for more details.
!
!    You should have received a copy of the GNU General Public License
!    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
program test

  use dal
  use ErrorHandling
  
  implicit none

  type(DataSetT) set
  type(TableT) tab
  type(ColumnT) col

  !call initerror("DALTEST")

  set = dataSet("test.dat",CREATE)
  tab = addTable(set,"some table",100)
  col = addColumn(tab,"col1",INTEGER32,"mm")
  col = addColumn(tab,"col2",INTEGER32,"mm", position=0 )
  col = addColumn(tab,"col3",INTEGER32,"mm")

  if (columnNumber(tab,"col1") /= 1) call error('',"invalid column number")
  if (columnNumber(tab,"col2") /= 0) call error('',"invalid column number")
  if (columnNumber(tab,"col3") /= 2) call error('',"invalid column number")

  call release(set)

  !call enderror()

end program test
