// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
#include<DataSetTracker.h>
#include<DataSetRecord.h>
#include<Dal.h>
#include<iostream>
#include<vector>

int main() {
    std::string name("datasetrecord.ds");
    DataSet * set = dataSetServer->open(name, Dal::Create);

    DataSetTracker trk;

    DataSetRecord & r = trk.make_record(name);
    r.dataSet(set);
    std::cout << "mode = " << r.mode() << std::endl;
    std::cout << "count = " << r.count() << std::endl;
    ++r; ++r;
    std::cout << "count = " << r.count() << std::endl;
    --r;
    std::cout << "count = " << r.count() << std::endl;

    std::cout << "Global count = " << trk.count() << std::endl;

    dataSetServer->close(set);
    r.dataSet(0);
    std::cout << "Global count = " << trk.count() << std::endl;

    std::cout << "list = " << std::endl;
    trk.list();
    std::cout << "active = " << r.active() << std::endl;
}
