// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
using namespace std;
//
// XMM Science Analysis System
//
// Giuseppe Vacanti (cosine science & computing) 
// September 2001
//

#include<iostream>
#include<string>
#include <Dal.h>

int main() {
  std::string name("spr1962.ds");
  dataSetServer->client("test");
  DataSet* set = dataSetServer->open(name, Dal::Create);
  Table* tab = set->addTable("table", 10);
  Column* col = tab->addColumn("column", Dal::Int32);
  ColumnData* cd = col->data();
  int32* v = cd->int32Data();
  delete cd;
  col->release();
  // This works
  //  tab->deleteColumn("column");

  longVec size(2,2);
  Array * arr = set->addArray("array", Dal::Int32, size);

  dataSetServer->close(set);

  std::cout << "Set created" << std::endl;

  set = dataSetServer->open(name, Dal::Modify);
  tab = set->table("table");
  col = tab->column("column");
  cd = col->data();
  // addColumn works
  //  tab->addColumn("column2", Dal::Int32);

  // SPR-1962
  // This fails in low memory.
  // Without delete cd, in low mem, deleteColumn will fail.

//    delete cd;

  tab->deleteColumn("column");

  arr = set->array("array");
  ArrayData * ad = arr->data();
  v = ad->int32Data();

  // idem
  //  delete ad;
  set->deleteBlock("array");

  dataSetServer->close(set);
  
}



