// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
//
// $Id: spr2289.cc,v 1.2 2004/03/05 14:43:04 eojero Exp $
//
#include<Dal.h>
#include <errstr.h>
#include<cassert>

// This is supposed to run after spr2289f90


using namespace std;

int main() {
  DataSet * set = dataSetServer->open("spr2289f90_in.ds", Dal::Modify);
  Table * tab = set->table("table");
  tab->seek(10, 10);
  Column * col = tab->column("column");
  ColumnData * cd = col->data();
  cd->setToNull(5);
  delete cd;
  dataSetServer->close(set);

  set = dataSetServer->open("spr2289f90_in.ds", Dal::Read);
  tab = set->table("table");
  col = tab->column("column");
  cd = col->data();

  // The following shows that SPR 2289 is confined to fortran

  assert(cd->isNull(15));

  // This catches (again) if the test spr2289f90 has failed
  if(cd->isNull(5))
    Sas::error("UnexpectedNull",
	       "I did not expect to see a NULL at element 5");

  delete cd;
  dataSetServer->close(set);

}
  
