! ESA (C) 2000-2018 
!
! This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
!
!    SAS is free software: you can redistribute it and/or modify
!    it under the terms of the GNU General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    SAS is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU General Public License for more details.
!
!    You should have received a copy of the GNU General Public License
!    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
program spr2289f90
  use dal
  use errorHandling

  type(DataSetT) :: set0
  type(TableT) :: tab0
  type(ColumnT) :: col0
  character(len = 20)  :: setname
  real(kind=double), dimension(:), pointer :: x

  call setClient("spr2289f90")
  setname = "spr2289f90_in.ds"
  set0 = dataSet(setname, CREATE)
  tab0 = addTable(set0, "table", 100)
  col0 = addColumn(tab0, "column", REAL64)
  x => real64Data(col0)
  x=124
  call release(col0)

  call seek(tab0, 10, 10)
  col0 = column(tab0, "column")
  call setToNull(col0, 5)
  
  call release(col0)
  call release(tab0)
  call release(set0)

  set0 = dataSet(setname, READ)
  tab0 = table(set0, "table")
  col0 = column(tab0, "column")
  x => real64Data(col0)

  if(isNull(col0, 5))then
    write(errstr,*)'Element 5 is null and it should not'
    call error("error")
  else if(isNull(col0, 15))then
    write(*,*)'Element 15 is null as it should'
  else
    write(errstr,*)'Neither element 5 nor 15 is null'
    call error("error")
 end if

end program spr2289f90
