// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
//  Giuseppe Vacanti (cosine science & computing bv)
//  January 27, 2003
// 
//   $Id: spr2360.cc,v 1.3 2009/06/22 15:58:03 rsaxton Exp $

#include<Dal.h>
#include<string>
#include<ExceptionErrorHandler.h>
#include<iostream>

#include<cassert>
#include<fitsio.h>

int main() {
    std::string f("spr2360.ds");
    DataSet * set = 0;


    // The DAL cannot read columns with bit field types.
    {
    	int status = 0;
	fitsfile *fptr;
	/* AI gcc4 porting
	 *  deprecated conversion from string constant to char*=> cast to (char*)
	 */
	char * ttype1[] = {(char*) "column" };
	char * tform1[] = {(char*)  "8X" };
	std::string fn("!");
	fn = fn + f;
	
	fits_create_file(&fptr, fn.c_str(), &status);
	fits_create_tbl(fptr, BINARY_TBL, 0, 0, 0, 0, 0, 0, &status);
	fits_insert_col(fptr, 1, ttype1[0], tform1[0], &status);
	fits_close_file(fptr, &status);        

	std::cout << " cfitsio status = " << status << std::endl;
	assert(status == 0);
    }

    try {
	SetExceptionErrorHandler eeh;
	set = dataSetServer->open(f, Dal::Read);
    }
    catch(SasException::Error e){
	std::cerr << "Saw:\n" << "code = " << e.code << "\n"
		  << "message = " << e.message << std::endl;
	assert(e.code == "FITSError");	
	return 0;
    }
    catch(...){
	std::cerr << "I was not expecting another exception." << std::endl;
	return 1;
    }

    std::cerr << "I expected an exception here. Boom." << std::endl;
    return 1;
    dataSetServer->close(set);
}
