// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
using namespace std;
#include <string>
#include <Dal.h>
#include <ErrorHandling.h>
#include <fstream>

void writeFits(const string& dataset, const string& fitsfile)
{
  DataSet *set = dataServer->open(dataset,Read);

  ofstream ofs(fitsfile.c_str());
  if (!ofs) Error("fileCreate",("Cannot create file "+fitsfile).c_str());

  dataServer->close(set);
}

int main(int argc, char *argv[])
{
  if (argc != 3)
	Error("commandLineArguments",
	      ("usage: "+string(argv[0])+" <dataset> <fitsfile>").c_str());
  writeFits(argv[1],argv[2]);
}
